package vo

type ReProjectTaskPreview struct {
	ProductId    int64   `json:"productId"`
	MainImage    string  `json:"mainImage"`
	ProductName  string  `json:"productName"`
	ProductPrice float64 `json:"productPrice"`

	EnterpriseId    string  `json:"enterpriseId"`
	SubAccountId    int64   `json:"subAccountId"`
	ProjectId       string  `json:"projectId"`
	ProjectPlatform int64   `json:"projectPlatform"`
	ProjectStatus   int64   `json:"projectStatus"`
	EstimatedCost   float64 `json:"estimatedCost"` // 任务成本
	ProjectForm     int64   `json:"projectForm"`
	ContentType     int64   `json:"contentType"`
	NeedReview      int64   `json:"needReview"`
	NeedQuality     int64   `json:"needQuality"`
	NeedCalculate   int64   `json:"needCalculate"`
	CreatorName     string  `json:"creatorName"`
	ProjectType     int64   `json:"projectType"`
	CreatedAt       string  `json:"createdAt"`
	Tools           string  `json:"tools"`
}
