package gorm_model

type YounggeeSubAccount struct {
	SubAccountId   int    `gorm:"column:sub_account_id;primary_key;AUTO_INCREMENT"` // 子账号ID
	PhoneNumber    string `gorm:"column:phone_number"`                              // 手机号
	SubAccountName string `gorm:"column:sub_account_name"`                          // 子账号名称
	JobId          int    `gorm:"column:job_id"`                                    // 岗位ID
	EnterpriseId   string `gorm:"column:enterprise_id"`                             // 所属商家账号ID
	AccountStatus  int    `gorm:"column:account_status"`                            // 账号状态，1为正常，2为停用
	UserId         int    `gorm:"column:user_id"`                                   // 用户表中ID
	SubAccountType int    `gorm:"column:sub_account_type"`                          // 子账号类型，1为商家端子账号，2为管理后台子账号
}

func (m *YounggeeSubAccount) TableName() string {
	return "younggee_sub_account"
}
